module Rakka.Storage.Types
    ( Storage(..)
    , IndexReq(..)
    )
    where

import           Control.Concurrent.STM
import           Rakka.Page
import           Subversion.Repository
import           Subversion.Types
import           Text.HyperEstraier hiding (WriteLock)


data Storage
    = Storage {
        stoRepository :: !Repository
      , stoIndexChan  :: !(TChan IndexReq)
      }


data IndexReq
    = RebuildIndex
    | SyncIndex
    | SearchIndex !Condition !(TMVar [(PageName, RevNum)])
